package com.hfkj.dao;

import com.hfkj.entity.StudentMsg;
import com.hfkj.entity.StudentMsgExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface StudentMsgMapper extends StudentMsgMapperExt {
    @SelectProvider(type=StudentMsgSqlProvider.class, method="countByExample")
    long countByExample(StudentMsgExample example);

    @DeleteProvider(type=StudentMsgSqlProvider.class, method="deleteByExample")
    int deleteByExample(StudentMsgExample example);

    @Delete({
        "delete from student_msg",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into student_msg (head_img, height, ",
        "father_height, mother_height, ",
        "weight, age, phone, ",
        "`name`, birthday, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{headImg,jdbcType=VARCHAR}, #{height,jdbcType=DECIMAL}, ",
        "#{fatherHeight,jdbcType=DECIMAL}, #{motherHeight,jdbcType=DECIMAL}, ",
        "#{weight,jdbcType=DECIMAL}, #{age,jdbcType=INTEGER}, #{phone,jdbcType=VARCHAR}, ",
        "#{name,jdbcType=VARCHAR}, #{birthday,jdbcType=TIMESTAMP}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(StudentMsg record);

    @InsertProvider(type=StudentMsgSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(StudentMsg record);

    @SelectProvider(type=StudentMsgSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="head_img", property="headImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="height", property="height", jdbcType=JdbcType.DECIMAL),
        @Result(column="father_height", property="fatherHeight", jdbcType=JdbcType.DECIMAL),
        @Result(column="mother_height", property="motherHeight", jdbcType=JdbcType.DECIMAL),
        @Result(column="weight", property="weight", jdbcType=JdbcType.DECIMAL),
        @Result(column="age", property="age", jdbcType=JdbcType.INTEGER),
        @Result(column="phone", property="phone", jdbcType=JdbcType.VARCHAR),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="birthday", property="birthday", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<StudentMsg> selectByExample(StudentMsgExample example);

    @Select({
        "select",
        "id, head_img, height, father_height, mother_height, weight, age, phone, `name`, ",
        "birthday, create_time, update_time, ext_1, ext_2, ext_3",
        "from student_msg",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="head_img", property="headImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="height", property="height", jdbcType=JdbcType.DECIMAL),
        @Result(column="father_height", property="fatherHeight", jdbcType=JdbcType.DECIMAL),
        @Result(column="mother_height", property="motherHeight", jdbcType=JdbcType.DECIMAL),
        @Result(column="weight", property="weight", jdbcType=JdbcType.DECIMAL),
        @Result(column="age", property="age", jdbcType=JdbcType.INTEGER),
        @Result(column="phone", property="phone", jdbcType=JdbcType.VARCHAR),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="birthday", property="birthday", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    StudentMsg selectByPrimaryKey(Long id);

    @UpdateProvider(type=StudentMsgSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") StudentMsg record, @Param("example") StudentMsgExample example);

    @UpdateProvider(type=StudentMsgSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") StudentMsg record, @Param("example") StudentMsgExample example);

    @UpdateProvider(type=StudentMsgSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(StudentMsg record);

    @Update({
        "update student_msg",
        "set head_img = #{headImg,jdbcType=VARCHAR},",
          "height = #{height,jdbcType=DECIMAL},",
          "father_height = #{fatherHeight,jdbcType=DECIMAL},",
          "mother_height = #{motherHeight,jdbcType=DECIMAL},",
          "weight = #{weight,jdbcType=DECIMAL},",
          "age = #{age,jdbcType=INTEGER},",
          "phone = #{phone,jdbcType=VARCHAR},",
          "`name` = #{name,jdbcType=VARCHAR},",
          "birthday = #{birthday,jdbcType=TIMESTAMP},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(StudentMsg record);
}